﻿
Public Class Form1

    Private WithEvents SHContextMenu As New ShellContextMenu

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        ' *******************************************************************
        ' Achtung: Befehle aus dem Shell-Kontextmenü werden stumpf ausgeführt!
        ' Löschen bedeutet auch löschen usw.! Ich über nehem keine Haftung
        ' wenn Ihr darüber Dateien/Ordner löscht oder Euer Laufwerk formatiert!
        ' *******************************************************************

        ' Hier können auch mehrere Dateien/Ordner angegeben
        ' werden, die auf dem selben Laufwerk/Ebene liegen!

        ' Laufwerke und Dateien/Ordner können nicht zusammen
        ' in der Liste sein!


        ' Bsp für eine Datei
        Dim FolderFile As New List(Of String) From {
            "C:\Windows\system.ini"
        }

        ' Bsp für zwei Dateien
        'Dim FolderFile As New List(Of String) From {
        '    "C:\Windows\system.ini",
        '    "C:\Windows\explorer.exe"
        '}

        ' Bsp für einen Ordner
        'Dim FolderFile As New List(Of String) From {
        '    "C:\Windows"
        '}

        ' Bsp für zwei Ordner
        'Dim FolderFile As New List(Of String) From {
        '    "C:\Windows\SoftwareDistribution",
        '    "C:\Windows\System32"
        '}

        ' Bsp für ein Laufwerk
        'Dim FolderFile As New List(Of String) From {
        '    "C:"
        '}

        ' Bsp für zwei Laufwerke
        'Dim FolderFile As New List(Of String) From {
        '    "C:", "D:"
        '}

        ' Bsp für einen ShellFolder
        'Dim FolderFile As New List(Of String) From {
        '    "::{20D04FE0-3AEA-1069-A2D8-08002B30309D}"
        '}

        ' Bsp für eine Datei/Ordner auf gleicher Ebene
        'Dim FolderFile As New List(Of String) From {
        '    "C:\Windows\system.ini",
        '    "C:\Windows\System32"
        '}

        ' BgMenu ist ein anderes Menü (geht nur für einen Ordner oder ein Laufwerk)
        If SHContextMenu.ShowContextMenu(FolderFile, Me, Me.Left + 50, Me.Top + 50) Then
            ' Befehl erfolgreich ausgeführt
        Else
            ' Menü wurde geschlossen ohne das ein MenüItem ausgewählt wurde
        End If

    End Sub

    Private Sub SHContextMenu_MenuCreated(MenuHandle As IntPtr) Handles SHContextMenu.MenuCreated
        ' KontextMenü wurde erstellt
    End Sub

    Private Sub SHContextMenu_MenuDestroyed() Handles SHContextMenu.MenuDestroyed
        ' KontextMenü wurde zerstört
    End Sub

    Private Sub SHContextMenu_MenuItem(MenuItemID As Integer, MenuItemString As String, MenuHandle As IntPtr) Handles SHContextMenu.MenuItem
        ' ein paar Infos über das MenuItem, das gerade aktiv ist
    End Sub

    Private Sub SHContextMenu_MenuItemReturn(MenuItemID As Integer, CommandString As String, HelpTextString As String) Handles SHContextMenu.MenuItemReturn
        ' ein paar Infos über das MenuItem, das ausgewählt wurde
        ' MenuItemID = 0 = kein MenuItem ausgwählt
    End Sub
End Class
